#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'
__date__ ='$01-enero-2011 20:00:00$'
#
# A simple application to look up for definitions
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import os
import sys, re
import gtk, gobject
import webkit
import urllib2
import locale
import gettext
import lxml.html as lh
from lxml.html.clean import clean_html
from ini import Ini
#
from preferences import PF
from preferences import urls

APP = 'define-me'
DIR = '/usr/share/locale-langpack'
APPDIR = '/usr/share/define-me/'
#APPDIR = '/home/atareao/Python/define-me/'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

def absfile(filename):
	return os.path.join(APPDIR,filename)

class SM(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self,busqueda_inicial = None):
		#
		if os.path.exists(os.path.join(os.getenv("HOME"),".define-me/"))==False:
			os.mkdir(os.path.join(os.getenv("HOME"),".define-me/"))
		filename = os.path.join(os.getenv("HOME"),".define-me/define-me.ini")
		self.ini=Ini(filename)
		self.language = self.ini.language
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title('define-me')
		self.set_default_size(600, 400)
		self.set_icon(gtk.gdk.pixbuf_new_from_file(absfile('define-me.svg')))
		self.connect('destroy', self.close_application)
		#
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#
		self.menubar = gtk.MenuBar()
		################################################################
		self.filemenu = gtk.Menu()
		self.filem = gtk.MenuItem(_('File'))
		self.filem.set_submenu(self.filemenu)
		#
		self.sal = gtk.ImageMenuItem(gtk.STOCK_QUIT)
		self.sal.connect('activate',self.on_exit_activate)
		self.filemenu.append(self.sal)
		#
		self.menubar.append(self.filem)
		################################################################
		self.fileedit = gtk.Menu()
		self.filee = gtk.MenuItem(_('Edit'))
		self.filee.set_submenu(self.fileedit)
		#
		self.pref = gtk.ImageMenuItem(gtk.STOCK_PREFERENCES)
		self.pref.connect('activate',self.on_preferences_activate)
		self.fileedit.append(self.pref)
		#
		self.menubar.append(self.filee)
		################################################################
		self.filehelp = gtk.Menu()
		self.fileh = gtk.MenuItem(_('Help'))
		self.fileh.set_submenu(self.filehelp)
		#
		self.about = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
		self.about.connect('activate',self.on_about_activate)
		self.filehelp.append(self.about)
		#
		self.menubar.append(self.fileh)
		################################################################
		self.vbox1.pack_start(self.menubar,False,False)	
		#
		self.toolbar = gtk.HBox(spacing=5)
		self.vbox1.pack_start(self.toolbar,False,False)	
		#
		self.button1 = gtk.Button()
		self.button1.add(gtk.Arrow(gtk.ARROW_LEFT,gtk.SHADOW_OUT))
		self.button1.connect('clicked',self._go_back)
		self.toolbar.pack_start(self.button1,False,False)
		#
		self.button2 = gtk.Button()
		self.button2.add(gtk.Arrow(gtk.ARROW_RIGHT,gtk.SHADOW_OUT))
		self.button2.connect('clicked',self._go_forward)
		self.toolbar.pack_start(self.button2,False,False)
		#
		self.text = gtk.Entry()
		self.text.connect('activate',self._open_bar_url)
		self.toolbar.pack_start(self.text,True,True)
		#
		self.button3 = gtk.Button()#
		self.button3.set_image(gtk.image_new_from_stock(gtk.STOCK_FIND,gtk.ICON_SIZE_BUTTON))
		self.button3.connect('clicked',self._open_bar_url)
		self.toolbar.pack_start(self.button3,False,False)
		# Combobox
		self.combobox = gtk.ComboBox()
		self.toolbar.pack_start(self.combobox,False,True)
		self.model = gtk.ListStore(str)
		if self.language in urls['wikipedia'].keys():
			self.model.append(['Wikipedia'])
		if self.language in urls['wordreference'].keys():
			self.model.append(['WordReference'])
		if self.language in urls['rae'].keys():
			self.model.append(['RAE'])
		if self.language in urls['dictionary.com'].keys():
			self.model.append(['Dictionary.com'])			
		self.combobox.set_model(self.model)
		cell = gtk.CellRendererText()
		self.combobox.pack_start(cell,True);
		self.combobox.add_attribute(cell,'text',0)
		self.combobox.set_active(0)
		#
		self.scrolled_window = gtk.ScrolledWindow()
		self.webview = webkit.WebView()
		self.scrolled_window.add(self.webview)
		self.vbox1.pack_start(self.scrolled_window, fill=True, expand=True)
		#
		self.pbar = gtk.ProgressBar()
		self.status = gtk.Label()
		hbox2 = gtk.HBox(False,0)
		hbox2.pack_start(self.status,False,False)
		hbox2.pack_end(self.pbar,False,False)
		self.vbox1.pack_start(hbox2,False,False)
		#
		self.webview.connect('load-started',self._load_start)
		self.webview.connect('load-progress-changed',self._load_progress_changed)
		self.webview.connect('load-finished',self._load_finished)
		self.webview.connect('title-changed',self._title_changed)
		self.webview.connect('hovering-over-link',self._hover_link)	
		self.webview.connect('navigation-requested', self._navigation_requested_cb)
		#
		# Inicializations
		#
		self.loading = False
		self.navigation = []
		self.whereiam = 0
		self.button1.set_sensitive(False)
		self.button2.set_sensitive(False)
		#
		#
		#
		itera = self.model.get_iter_first()
		while itera != None:
			if self.model.get_value(itera,0) == self.ini.dictionary:
				break					
			itera = self.model.iter_next(itera)
		if itera != None:
			self.combobox.set_active_iter(itera)
		else:
			self.combobox.set_active(0)
		#
		self.show_all()
		#
		#
		#
		if busqueda_inicial!= None:
			self._load(busqueda_inicial)
			self.text.set_text(busqueda_inicial)
				 
	def _navigation_requested_cb(self,view, frame, networkRequest):
		uri=networkRequest.get_uri()
		if self.loading ==False:
			self._loader(uri)
			self.navigation.append({'language':self.language,'dictionary':self.combobox.get_active_text(),'word':self.text.get_text()})
			self.whereiam = self.whereiam + 1
			if self.whereiam > 1:
				self.button1.set_sensitive(True)
			return 1
		return 0

	def _open_bar_url(self, nada):
		self.open(self.text.get_text())
	
	def _loader(self,uri):
		if uri != None:
			self.loading = True
			try:
				if uri.startswith(urls['wikipedia'][self.language]):
					code = urllib2.urlopen(urllib2.Request(uri, headers={'User-Agent' : "Magic Browser"}))
					encoding = (code.info().plist[0].split('=')[1])
					doc = lh.document_fromstring(clean_html(unicode(code.read(),encoding)))
					result = lh.tostring(doc.get_element_by_id('bodyContent'),method = 'html', encoding = encoding)
					self.webview.load_string(result, 'text/html', encoding, uri)
					self.text.set_text(unicode(uri.split(urls['wikipedia'][self.language])[1],encoding))				
				elif uri.startswith(urls['wordreference'][self.language]):
					code = urllib2.urlopen(urllib2.Request(uri, headers={'User-Agent' : "Magic Browser"}))
					encoding = (code.info().plist[0].split('=')[1])
					doc = lh.document_fromstring(clean_html(unicode(code.read(),encoding)))
					trans = doc.find_class('trans')
					if len(trans)>0:
						trans_tmp = ''
						for t in trans:
							trans_tmp = trans_tmp + lh.tostring(t,method = 'html', encoding = encoding)
						self.webview.load_string(trans_tmp, 'text/html', encoding, uri)
						self.text.set_text(unicode(uri.split(urls['wordreference'][self.language])[1],encoding))	
					else:
						raise urllib2.HTTPError(uri, '404', '404', None, None)
				elif uri.startswith(urls['dictionary.com']['es']):
					code = urllib2.urlopen(urllib2.Request(uri, headers={'User-Agent' : "Magic Browser"}))
					encoding = (code.info().plist[0].split('=')[1])
					doc = lh.document_fromstring(clean_html(unicode(code.read(),encoding)))
					print doc
					body = doc.find_class('tab_contents tab_contents_active')
					print body
					if len(body)>0:
						body_tmp = ''
						for b in body:
							body_tmp = body_tmp + lh.tostring(b,method = 'html', encoding = encoding)
						self.webview.load_string(body_tmp, 'text/html', encoding, uri)
						self.text.set_text(unicode(uri.split(urls['dictionary.com'][self.language])[1],encoding))	
				elif uri.startswith(urls['dictionary.com']['en']):
					code = urllib2.urlopen(urllib2.Request(uri, headers={'User-Agent' : "Magic Browser"}))
					encoding = (code.info().plist[0].split('=')[1])
					doc = lh.document_fromstring(clean_html(unicode(code.read(),encoding)))
					print doc
					body = doc.find_class('sep_top shd_hdr pb7')
					print body
					if len(body)>0:
						body_tmp = ''
						for b in body:
							body_tmp = body_tmp + lh.tostring(b,method = 'html', encoding = encoding)
						self.webview.load_string(body_tmp, 'text/html', encoding, uri)
						self.text.set_text(unicode(uri.split(urls['dictionary.com'][self.language])[1],encoding))	
						
				elif uri.startswith(urls['rae'][self.language]):
					self.webview.open(uri)
					print uri
					self.text.set_text(uri.split(urls['rae'][self.language])[1])	
				elif uri.startswith('http://buscon.rae.es/draeI/SrvltObtenerHtml?origen=RAE&LEMA='):
					print 'aqui no'
					uri = urls['rae'][self.language]+uri.split('&')[1].split('=')[1]
					self.webview.open(uri)
					self.text.set_text(uri.split(urls['rae'][self.language])[1])
			except urllib2.HTTPError:
				self.webview.load_string('<p><b>'+_('Not found')+'</b></p>', 'text/html', 'UTF-8', uri)								
			self.loading = False

	def _load(self, texto):
		searchfor = None
		if self.combobox.get_active_text() == 'Wikipedia':
			searchfor = urls['wikipedia'][self.language] + texto
		elif self.combobox.get_active_text() == 'WordReference':
			searchfor = urls['wordreference'][self.language] + texto
		elif self.combobox.get_active_text() == 'RAE':
			searchfor = urls['rae'][self.language] + texto
		elif self.combobox.get_active_text() == 'Dictionary.com':
			searchfor = urls['dictionary.com'][self.language] + texto
			print searchfor
		if searchfor != None:
			self._loader(searchfor)
			
	def open(self, url):
		self._load(url)
		
	def show(self):
		self.window.show_all()
		
	def close_application(self, widget, event, data=None):
		exit(0)
		
	def _load_start(self, view, nadas):
		self.status.set_text('Cargando...')
		self.pbar.set_fraction(0)
		
	def _load_progress_changed(self, view, prog):
		self.pbar.set_fraction(prog/100.0)
	
	def _load_finished(self, view, nada):
		self.pbar.set_fraction(0)
		self.status.set_text('Listo')
	
	def _go_back(self,nada):
		if len(self.navigation)>0 and self.whereiam > 0:
			self.whereiam = self.whereiam -1
			self.language = self.navigation[self.whereiam]['language']
			dictionary = self.navigation[self.whereiam]['dictionary']
			if dictionary == 'Wikipedia':
				self.combobox.set_active(0)
			elif dictionary == 'WordReference':
				self.combobox.set_active(1)
			elif dictionary == 'RAE':
				self.combobox.set_active(2)
			elif dictionary == 'Dictionary.com':
				self.combobox.set_active(3)				
			word = self.navigation[self.whereiam]['word']
			self._load(word)
		if self.whereiam >0:
			self.button1.set_sensitive(True)
		else:
			self.button1.set_sensitive(False)
		if self.whereiam < (len(Self.navigation)-2):
			self.button2.set_sensitive(True)
		else:
			self.button2.set_sensitive(False)
	
	def _go_forward(self,nada):
		if len(self.navigation)>0 and self.whereiam < (len(self.navigation)-1):
			self.whereiam = self.whereiam + 1
			self.language = self.navigation[self.whereiam]['language']
			dictionary = self.navigation[self.whereiam]['dictionary']
			if dictionary == 'Wikipedia':
				self.combobox.set_active(0)
			elif dictionary == 'WordReference':
				self.combobox.set_active(1)
			elif dictionary == 'RAE':
				self.combobox.set_active(2)
			elif dictionary == 'Dictionary.com':
				self.combobox.set_active(3)
			word = self.navigation[self.whereiam]['word']
			self._load(word)
		if self.whereiam >0:
			self.button1.set_sensitive(True)
		else:
			self.button1.set_sensitive(False)
		if self.whereiam < (len(Self.navigation)-2):
			self.button2.set_sensitive(True)
		else:
			self.button2.set_sensitive(False)

	
	def _refresh(self,nada):
		self.webview.reload()
	
	def _title_changed(self,view,frame,title):
		# Actualizo el titulo del navegador, la url en la barra de url y activo/desactivo los botones Adelante y Atras
		self.set_title('%s' % title)
		#self.text.set_text(frame.get_uri())
		self.button1.props.sensitive = self.webview.can_go_back()
		self.button2.props.sensitive = self.webview.can_go_forward()
	
	def _hover_link(self,view,frame,url):
		# Si se hace hover sobre un link, pongo en la barra de estado la url hacia la que linkea
		if view and url and self.combobox.get_active_text() == 'Wikipedia':
			#self.status.set_text(url)
			self.status.set_text(url.split('/')[-1:][0])
		elif view and url and self.combobox.get_active_text() == 'WordReference':
			pass
		elif view and url and self.combobox.get_active_text() == 'Dictionary.com':
			pass
		elif view and url and self.combobox.get_active_text() == 'RAE' and url.find('LEMA='):
			inicio = url.find('LEMA=')+5
			fin  = url.find('&',inicio)
			if fin > inicio:
				self.status.set_text(url[inicio:fin])
			else:
				self.status.set_text('')
		else:
			self.status.set_text('')
	def on_exit_activate(self,widget):
		exit(0)

	def on_preferences_activate(self,widget):
		pf = PF(self.ini)
		pf.run()
		if pf.ok == True:
			self.ini.language = pf.language
			self.ini.dictionaty = pf.dictionary
			self.ini.write()
			self.language = pf.language
			#
			self.model.clear()
			if self.language in urls['wikipedia'].keys():
				self.model.append(['Wikipedia'])
			if self.language in urls['wordreference'].keys():
				self.model.append(['WordReference'])
			if self.language in urls['rae'].keys():
				self.model.append(['RAE'])
			if self.language in urls['dictionary.com'].keys():
				self.model.append(['Dictionary.com'])
			#
			itera = self.model.get_iter_first()
			while itera != None:
				if self.model.get_value(itera,0) == pf.dictionary:
					break					
				itera = self.model.iter_next(itera)
			if itera != None:
				self.combobox.set_active_iter(itera)
			else:
				self.combobox.set_active(0)

	def on_about_activate(self,widget):
		ad=gtk.AboutDialog()
		ad.set_name('define-me')
		ad.set_version('0.2.0')
		ad.set_copyright('Copyright (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A simple application to find the definition of words'))
		ad.set_license(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.')
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits('Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>')		
		ad.set_program_name('define-me')
		ad.set_logo(gtk.gdk.pixbuf_new_from_file(absfile('define-me.svg')))
		ad.run()
		ad.hide()			

if __name__ == '__main__':
	sm = SM()
	sm.run()
