#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import ConfigParser
import os

VERSION = '1.0'

class Ini:
	def __init__(self,inifile):
		self.inifile=inifile
		self.language='es'
		self.dictionary='RAE'
		self.version = VERSION
		if os.path.exists(inifile)==False:
			self.write()
		else:
			self.read()

	def read(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Configuration'):
			self.write()
		else:
			self.language=ini.get('Configuration','Language')
			self.dictionary=ini.get('Configuration','Dictionary')
			self.version=ini.get('Configuration','Version')
	def write(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Configuration'):
			ini.add_section('Configuration')
		ini.set('Configuration','Language',self.language)
		ini.set('Configuration','Dictionary',self.dictionary)
		ini.set('Configuration','Version',self.version)
		with open(self.inifile,'wb') as writefile:
			ini.write(writefile)
