#!/usr/bin/python
import sys, re
import gtk, gobject
import locale
import gettext
from ini import Ini

APP = 'define-me'
DIR = '/usr/share/locale-langpack'
APPDIR = '/usr/share/define-me/'
#APPDIR = '/home/atareao/Python/define-me/'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

languages = {}
languages[_('Deutch')]='de'
languages[_('English')]='en'
languages[_('French')]='fr'
languages[_('Spanish')]='es'
languages[_('Italian')]='it'

codes = {}
codes['de'] = _('Deutch')
codes['en'] = _('English')
codes['fr'] = _('French')
codes['es'] = _('Spanish')
codes['it'] = _('Italian')


urls = {}

urls['wikipedia'] = {'es':'http://es.wikipedia.org/wiki/',
					'en':'http://en.wikipedia.org/wiki/',
					'fr':'http://fr.wikipedia.org/wiki/',
					'it':'http://it.wikipedia.org/wiki/',
					'de':'http://de.wikipedia.org/wiki/'}
urls['wordreference'] = {'es':'http://www.wordreference.com/definicion/',
						'en':'http://www.wordreference.com/definition/',
						'it':'http://www.wordreference.com/definizione/'}
urls['rae'] = {'es':'http://buscon.rae.es/draeI/SrvltGUIBusUsual?origen=RAE&LEMA='}
#urls['rae'] = {'es':'http://buscon.rae.es/draeI/SrvltConsulta?TIPO_BUS=3&LEMA='}
urls['dictionary.com'] = {'es':'http://spanish.dictionary.com/definition/',
						  'en':'http://dictionary.reference.com/browse/'}


class PF(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self,ini):
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title(_('Preferences'))
		self.set_default_size(10, 10)
		self.connect('destroy', self.close_application)
		#
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#
		self.hbox1 = gtk.HBox(spacing=5)
		self.vbox1.pack_start(self.hbox1,False,False)	
		#
		self.label1 = gtk.Label(_('Language')+': ')
		self.hbox1.pack_start(self.label1,False,False)
		#
		self.combobox1 = gtk.ComboBox()
		self.model1 = gtk.ListStore(str)
		for language in languages:
			self.model1.append([language])
		self.combobox1.set_model(self.model1)
		cell1 = gtk.CellRendererText()
		self.combobox1.pack_start(cell1,True);
		self.combobox1.add_attribute(cell1,'text',0)
		self.combobox1.set_active(0)
		self.combobox1.connect('changed',self.on_selection_changed)
		self.hbox1.pack_start(self.combobox1,True,True)
		#
		self.hbox2 = gtk.HBox(spacing=5)
		self.vbox1.pack_start(self.hbox2,False,False)	
		#
		self.label2 = gtk.Label(_('Prefered')+': ')
		self.hbox2.pack_start(self.label2,False,False)
		#
		self.combobox2 = gtk.ComboBox()
		self.model2 = gtk.ListStore(str)
		self.model2.append(['Wikipedia'])
		self.model2.append(['WordReference'])
		self.model2.append(['RAE'])
		self.model2.append(['Dictionary.com'])
		self.combobox2.set_model(self.model2)
		cell2 = gtk.CellRendererText()
		self.combobox2.pack_start(cell2,True);
		self.combobox2.add_attribute(cell2,'text',0)
		self.combobox2.set_active(0)
		self.hbox2.pack_start(self.combobox2,True,True)
		#
		self.hbox3 = gtk.HBox(spacing=5)
		self.vbox1.pack_start(self.hbox3,False,False)	
		#		
		self.button1 = gtk.Button(_('Ok'))#
		self.button1.set_image(gtk.image_new_from_stock(gtk.STOCK_OK,gtk.ICON_SIZE_BUTTON))
		self.button1.connect('clicked',self.on_ok_activate)
		self.hbox3.pack_start(self.button1,True,True)
		#		
		self.button2 = gtk.Button(_('Cancel'))#
		self.button2.set_image(gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON))
		self.button2.connect('clicked',self.on_exit_activate)
		self.hbox3.pack_start(self.button2,True,True)
		#
		#
		#
		self.language = ini.language
		self.dictionary = ini.dictionary
		self.ok = False
		#
		itera = self.model1.get_iter_first()
		while itera != None:
			if self.model1.get_value(itera,0) == codes[self.language]:
				break					
			itera = self.model1.iter_next(itera)
		if itera != None:
			self.combobox1.set_active_iter(itera)
		else:
			self.combobox1.set_active(0)
		#
		#
		itera = self.model2.get_iter_first()
		while itera != None:
			if self.model2.get_value(itera,0) == self.dictionary:
				break					
			itera = self.model2.iter_next(itera)
		if itera != None:
			self.combobox2.set_active_iter(itera)
		else:
			self.combobox2.set_active(0)
		#
		self.show_all()
	
	def close_application(self, widget, event, data=None):
		self.language = None
		self.dictionary = None
		self.ok = False
		self.hide()
	
	def on_ok_activate(self,widget):
		self.language = languages[self.combobox1.get_active_text()]
		self.dictionary = self.combobox2.get_active_text()
		self.ok = True
		self.hide()
		
		
	def on_exit_activate(self,widget):
		self.language = None
		self.dictionary = None
		self.ok = False
		self.hide()

	def on_selection_changed(self,widget):
		self.model2.clear()
		language = languages[self.combobox1.get_active_text()]
		if language in urls['wikipedia'].keys():
			self.model2.append(['Wikipedia'])
		if language in urls['wordreference'].keys():
			self.model2.append(['WordReference'])
		if language in urls['rae'].keys():
			self.model2.append(['RAE'])
		if language in urls['dictionary.com'].keys():
			self.model2.append(['Dictionary.com'])
		self.combobox2.set_active(0)

if __name__ == '__main__':
	pf = PF()
	pf.run()

